"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Global_1 = require("../../Runtime/Global");
var Object_1 = require("../../Object");
var Type_1 = require("../../Type");
var Dictionary = (function (_super) {
    __extends(Dictionary, _super);
    function Dictionary() {
        var _this = _super.call(this) || this;
        _this._pairs = new Map();
        return _this;
    }
    Object.defineProperty(Dictionary.prototype, "count", {
        get: function () {
            return this._pairs.size;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dictionary.prototype, "isReadOnly", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dictionary.prototype, "keys", {
        get: function () {
            var keys = Array();
            this._pairs.forEach(function (value, key, map) {
                keys.push(key);
            });
            return KeyCollection.of(keys);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dictionary.prototype, "item", {
        get: function () {
            return this._pairs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dictionary.prototype, "values", {
        get: function () {
            var values = Array();
            this._pairs.forEach(function (value, key, map) {
                values.push(value);
            });
            return ValueCollection.of(values);
        },
        enumerable: true,
        configurable: true
    });
    Dictionary.prototype.add = function (pair) {
        this._pairs[pair.key.toString()] = pair;
    };
    Dictionary.prototype.clear = function () {
        var _this = this;
        Global_1.default.Object
            .keys(this._pairs)
            .forEach(function (key) { return delete _this._pairs[key]; });
    };
    Dictionary.prototype.contains = function (pair) {
        return (!!this._pairs[pair.key.toString()]);
    };
    Dictionary.prototype.getEnumerator = function () {
        var _this = this;
        var pairs = new Array();
        Global_1.default.Object
            .keys(this._pairs)
            .forEach(function (key) { return pairs.push(_this._pairs[key]); });
        return DictionaryEnumerator.of(pairs);
    };
    Dictionary.prototype.getType = function () {
        return new Type_1.default(this, 'System.Collections.Generic');
    };
    Dictionary.prototype.remove = function (pair) {
        delete this._pairs[pair.key.toString()];
    };
    return Dictionary;
}(Object_1.default));
exports.Dictionary = Dictionary;
exports.default = Dictionary;
var DictionaryEnumerator = (function (_super) {
    __extends(DictionaryEnumerator, _super);
    function DictionaryEnumerator(pairs) {
        var _this = _super.call(this) || this;
        _this._pairs = pairs;
        _this._pairsLength = pairs.length;
        _this.reset();
        return _this;
    }
    DictionaryEnumerator.of = function (pairs) {
        return new DictionaryEnumerator(pairs);
    };
    Object.defineProperty(DictionaryEnumerator.prototype, "current", {
        get: function () {
            return this._current;
        },
        enumerable: true,
        configurable: true
    });
    DictionaryEnumerator.prototype.dispose = function () {
        delete this._current;
        delete this._pairs;
        delete this._pairsLength;
        delete this._position;
    };
    DictionaryEnumerator.prototype.getType = function () {
        return new Type_1.default(this, 'System.Collection.Generic.Dictionary');
    };
    DictionaryEnumerator.prototype.moveNext = function () {
        if (++this._position < this._pairsLength) {
            this._current = this._pairs[this._position];
            return true;
        }
        else {
            this._current = null;
            return false;
        }
    };
    DictionaryEnumerator.prototype.reset = function () {
        this._current = null;
        this._position = -1;
    };
    return DictionaryEnumerator;
}(Object_1.default));
var KeyCollection = (function (_super) {
    __extends(KeyCollection, _super);
    function KeyCollection(keys) {
        var _this = _super.call(this) || this;
        _this._keys = keys;
        return _this;
    }
    KeyCollection.of = function (keys) {
        return new KeyCollection(keys);
    };
    Object.defineProperty(KeyCollection.prototype, "count", {
        get: function () {
            return this._keys.length;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(KeyCollection.prototype, "isReadOnly", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    KeyCollection.prototype.add = function (key) {
    };
    KeyCollection.prototype.clear = function () {
    };
    KeyCollection.prototype.contains = function (key) {
        for (var index = 0, indexEnd = this._keys.length; index < indexEnd; ++index) {
            if (key.equals(this._keys[index])) {
                return true;
            }
        }
        return false;
    };
    KeyCollection.prototype.getEnumerator = function () {
        return KeyCollectionEnumerator.of(this._keys);
    };
    KeyCollection.prototype.getType = function () {
        return new Type_1.default(this, 'System.Collection.Generic.Dictionary');
    };
    KeyCollection.prototype.remove = function (key) {
    };
    return KeyCollection;
}(Object_1.default));
var KeyCollectionEnumerator = (function (_super) {
    __extends(KeyCollectionEnumerator, _super);
    function KeyCollectionEnumerator(keys) {
        var _this = _super.call(this) || this;
        _this._keys = keys;
        _this._keysLength = keys.length;
        _this.reset();
        return _this;
    }
    KeyCollectionEnumerator.of = function (keys) {
        return new KeyCollectionEnumerator(keys);
    };
    Object.defineProperty(KeyCollectionEnumerator.prototype, "current", {
        get: function () {
            return this._current;
        },
        enumerable: true,
        configurable: true
    });
    KeyCollectionEnumerator.prototype.dispose = function () {
        delete this._current;
        delete this._keys;
        delete this._keysLength;
        delete this._position;
    };
    KeyCollectionEnumerator.prototype.getType = function () {
        return new Type_1.default(this, 'System.Collection.Generic.Dictionary');
    };
    KeyCollectionEnumerator.prototype.moveNext = function () {
        if (++this._position < this._keysLength) {
            this._current = this._keys[this._position];
            return true;
        }
        else {
            this._current = null;
            return false;
        }
    };
    KeyCollectionEnumerator.prototype.reset = function () {
        this._current = null;
        this._position = -1;
    };
    return KeyCollectionEnumerator;
}(Object_1.default));
var ValueCollection = (function (_super) {
    __extends(ValueCollection, _super);
    function ValueCollection(values) {
        var _this = _super.call(this) || this;
        _this._values = values;
        return _this;
    }
    ValueCollection.of = function (values) {
        return new ValueCollection(values);
    };
    Object.defineProperty(ValueCollection.prototype, "count", {
        get: function () {
            return this._values.length;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ValueCollection.prototype, "isReadOnly", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    ValueCollection.prototype.add = function (value) {
    };
    ValueCollection.prototype.clear = function () {
    };
    ValueCollection.prototype.contains = function (value) {
        for (var index = 0, indexEnd = this._values.length; index < indexEnd; ++index) {
            if (value.equals(this._values[index])) {
                return true;
            }
        }
        return false;
    };
    ValueCollection.prototype.getEnumerator = function () {
        return ValueCollectionEnumerator.of(this._values);
    };
    ValueCollection.prototype.getType = function () {
        return new Type_1.default(this, 'System.Collection.Generic.Dictionary');
    };
    ValueCollection.prototype.remove = function (key) {
    };
    return ValueCollection;
}(Object_1.default));
var ValueCollectionEnumerator = (function (_super) {
    __extends(ValueCollectionEnumerator, _super);
    function ValueCollectionEnumerator(values) {
        var _this = _super.call(this) || this;
        _this._values = values;
        _this._valuesLength = values.length;
        _this.reset();
        return _this;
    }
    ValueCollectionEnumerator.of = function (keys) {
        return new ValueCollectionEnumerator(keys);
    };
    Object.defineProperty(ValueCollectionEnumerator.prototype, "current", {
        get: function () {
            return this._current;
        },
        enumerable: true,
        configurable: true
    });
    ValueCollectionEnumerator.prototype.dispose = function () {
        delete this._current;
        delete this._values;
        ;
        delete this._valuesLength;
        delete this._position;
    };
    ValueCollectionEnumerator.prototype.getType = function () {
        return new Type_1.default(this, 'System.Collection.Generic.Dictionary');
    };
    ValueCollectionEnumerator.prototype.moveNext = function () {
        if (++this._position < this._valuesLength) {
            this._current = this._values[this._position];
            return true;
        }
        else {
            this._current = null;
            return false;
        }
    };
    ValueCollectionEnumerator.prototype.reset = function () {
        this._current = null;
        this._position = -1;
    };
    return ValueCollectionEnumerator;
}(Object_1.default));
