/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
import IEquatable from '../../IEquatable';
import KeyValuePair from './KeyValuePair';
/**
 * Represents a generic dictionary.
 */
export interface IDictionary<TKey extends IEquatable<TKey>, TValue extends IEquatable<TValue>> {
    /**
     * The underlying dictionary with key value pairs.
     */
    item: {
        [key: string]: KeyValuePair<TKey, TValue>;
    };
}
export default IDictionary;
