/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
import IEnumerator from './IEnumerator';
/**
 * Provides a function to iterate through the collection.
 */
export interface IEnumerable<T extends Object> {
    /**
     * Returns an enumerator that iterates through the collection.
     * @return {IEnumerator} Returns the enumerator for the collection.
     */
    getEnumerator(): IEnumerator<T>;
}
export default IEnumerable;
