"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Global_1 = require("./Runtime/Global");
var Object_1 = require("./Object");
var RuntimeUtility_1 = require("./Runtime/RuntimeUtility");
var Type_1 = require("./Type");
var Event = (function (_super) {
    __extends(Event, _super);
    function Event() {
        var _this = _super.call(this) || this;
        _this._eventHandlers = {};
        return _this;
    }
    Event.prototype.add = function (eventHandler) {
        if (!eventHandler.uniqueID) {
            eventHandler.uniqueID = RuntimeUtility_1.default.generateUniqueHashCode();
        }
        this._eventHandlers[eventHandler.uniqueID.toString(16)] = eventHandler;
        return eventHandler;
    };
    Event.prototype.getType = function () {
        return new Type_1.default(this, 'System');
    };
    Event.prototype.raise = function (sender, e) {
        var _this = this;
        Global_1.default.Object.keys(this._eventHandlers).forEach(function (key) {
            Global_1.default.setTimeout(function () { return _this._eventHandlers[key](sender, e); }, 1);
        });
    };
    Event.prototype.remove = function (eventHandler) {
        if (eventHandler.uniqueID) {
            delete this._eventHandlers[eventHandler.uniqueID.toString(16)];
        }
    };
    return Event;
}(Object_1.default));
exports.Event = Event;
exports.default = Event;
