/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
import String from './String';
import TypeCode from './TypeCode';
/**
 * Represents basic types and provides functions to convert them among themselves.
 */
export interface IConvertible {
    /**
     * Returns the type code of this object.
     * @returns {System.TypeCode} The type code of this object.
     */
    getTypeCode(): TypeCode;
    /**
     * Converts the object to a string.
     * @returns {System.String} The string equivalent of this object.
     */
    toSystemString(): String;
}
export default IConvertible;
