/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
/**
 * Provides a generic interface for class specific equal tests.
 */
export interface IEquatable<T> {
    /**
     * Compares this object with an other object for equality.
     * @param {T|null} other The object to compare with.
     * @return {boolean} Returns true, if the objects are equal, otherwise false.
     */
    equals(other: (T | null)): boolean;
}
export default IEquatable;
