/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
import IEquatable from './IEquatable';
import * as System from './index';
/**
 * The base class for all other classes.
 * @implements IEquatable<System.Object>
 */
export declare class Object_ implements IEquatable<System.Object> {
    private __hashCode;
    /**
     * Compares this object with an other object for equality.
     * @param {System.Object|null} other The object to compare with.
     * @return {boolean} True, if the objects are equal, otherwise false.
     */
    equals(other: (System.Object | null)): boolean;
    /**
     * Generates or returns a unique code for this object. Should be
     * overwritten by value based classes.
     * @return {number} The unique code for this object.
     */
    getHashCode(): number;
    /**
     * Returns the type of an object for further reflection. Must be
     * overwritten by every class.
     * @return {System.Type} The type of this object.
     */
    getType(): System.Type;
    /**
     * Returns the class name as the default string representation for an
     * object. Must be overwritten by value based classes.
     * @return {string} The string representation of the object.
     */
    toString(): string;
    /**
     * Returns the primitive value for an object. Must be overwritten by value
     * based classes.
     * @return {number} The primitive value of the object.
     */
    valueOf(): any;
}
export default Object_;
