"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
var RuntimeUtility_1 = require("./Runtime/RuntimeUtility");
var System = require("./index");
var Object_ = (function () {
    function Object_() {
    }
    Object_.prototype.equals = function (other) {
        return (other != null
            && other.getHashCode() == this.getHashCode());
    };
    Object_.prototype.getHashCode = function () {
        if (!this.__hashCode) {
            this.__hashCode = RuntimeUtility_1.default.generateUniqueHashCode();
        }
        return this.__hashCode;
    };
    Object_.prototype.getType = function () {
        return new System.Type(this, 'System');
    };
    Object_.prototype.toString = function () {
        return this.getType().toString();
    };
    Object_.prototype.valueOf = function () {
        return this.getHashCode();
    };
    return Object_;
}());
exports.Object_ = Object_;
exports.default = Object_;
