/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
export declare module RuntimeUtility {
    const MAX_SAFE_INTEGER = 9007199254740991;
    /**
     * Generates unique codes for strings.
     * This code is only unique for the current runtime session.
     * @param {string} str The string to generate the unique code of.
     * @returns {number} The hash code of the string.
     */
    function generateStringHashCode(str: string): number;
    /**
     * Generates unique codes for objects.
     * This code is only unique for the current runtime session.
     * @returns {number} The unique hash code for an object.
     */
    function generateUniqueHashCode(): number;
}
export default RuntimeUtility;
