"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Object_1 = require("./Object");
var RuntimeUtility_1 = require("./Runtime/RuntimeUtility");
var Type_1 = require("./Type");
var TypeCode_1 = require("./TypeCode");
var String = (function (_super) {
    __extends(String, _super);
    function String(value) {
        var _this = _super.call(this) || this;
        _this._value = (value || '');
        return _this;
    }
    String.prototype.endsWith = function (value) {
        var thisValue = this._value;
        var index = thisValue.lastIndexOf(value);
        return (index >= 0
            && index == (thisValue.length - value.length));
    };
    String.prototype.equals = function (other) {
        if (other === null) {
            return false;
        }
        else if (other instanceof String) {
            return (other._value === this._value);
        }
        else {
            return this.equals(other);
        }
    };
    String.prototype.getHashCode = function () {
        if (!this._hashCode) {
            this._hashCode = RuntimeUtility_1.default.generateStringHashCode(this._value);
        }
        return this._hashCode;
    };
    String.prototype.getType = function () {
        return new Type_1.default(this, 'System');
    };
    String.prototype.getTypeCode = function () {
        return TypeCode_1.default.String;
    };
    String.prototype.startsWith = function (value) {
        return (this._value.indexOf(value) == 0);
    };
    String.prototype.toSystemString = function () {
        return this;
    };
    String.prototype.valueOf = function () {
        return this._value;
    };
    return String;
}(Object_1.default));
String.EMPTY = new String();
exports.String = String;
exports.default = String;
