"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Object_1 = require("./Object");
var RuntimeUtility_1 = require("./Runtime/RuntimeUtility");
var Type = (function (_super) {
    __extends(Type, _super);
    function Type(obj, namespace) {
        var _this = _super.call(this) || this;
        _this._directoryPath = (namespace ? namespace.replace('.', '/') : null);
        _this._name = obj.constructor.name;
        _this._namespace = (namespace || null);
        _this._numberOfArguments = obj.constructor.length;
        return _this;
    }
    Type.getType = function (name, namespace) {
        var requiredClass = require((namespace == '' ? '.' : namespace.replace('.', '/')) + '/ ' + name);
        if (requiredClass) {
            return new Type({ 'constructor': requiredClass }, namespace);
        }
        else {
            return null;
        }
    };
    Object.defineProperty(Type.prototype, "directoryPath", {
        get: function () {
            return this._directoryPath;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Type.prototype, "fullName", {
        get: function () {
            if (this.namespace) {
                return this.namespace + '.' + this._name;
            }
            else {
                return this._name;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Type.prototype, "namespace", {
        get: function () {
            return this._namespace;
        },
        enumerable: true,
        configurable: true
    });
    Type.prototype.equals = function (other) {
        if (other === null) {
            return false;
        }
        else if (other instanceof Type) {
            return (other._name === this._name
                && other._directoryPath === this._directoryPath);
        }
        else {
            return this.equals(other.getType());
        }
    };
    Type.prototype.getHashCode = function () {
        if (!this._hashCode) {
            this._hashCode = RuntimeUtility_1.default.generateStringHashCode(this.fullName);
        }
        return this._hashCode;
    };
    Type.prototype.toString = function () {
        return this.fullName.toString();
    };
    Type.prototype.getType = function () {
        return this;
    };
    return Type;
}(Object_1.default));
exports.Type = Type;
exports.default = Type;
