/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
import Enum from './Enum';
import Type from './Type';
/**
 *
 * extends System.Enum
 */
export declare class TypeCode extends Enum {
    /**
     * The null type representing the null reference.
     */
    static readonly Empty: TypeCode;
    /**
     * The generic type for any object not explicitly represented.
     */
    static readonly Object: TypeCode;
    /**
     * The string type representing unicode text strings.
     */
    static readonly String: TypeCode;
    getType(): Type;
}
export default TypeCode;
